routes/web.php
<?php

use App\Http\Controllers\Admin\CompanyController;
use App\Http\Controllers\Admin\EmployeeController;
use App\Http\Controllers\AuthController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [AuthController::class, 'home'])->name('home');
Route::get('/dashboard', [AuthController::class, 'dashboard'])->name('dashboard.index');

Route::get('/login', [AuthController::class, 'index'])->name('login.index');
Route::post('/login', [AuthController::class, 'login'])->name('login');
Route::get('/logout', [AuthController::class, 'logout'])->name('logout');

Route::group(['middleware' => ['auth'], 'prefix' => 'admin', 'as' => 'admin.'], function () {
    Route::resource('companies', CompanyController::class)->except('show');
    Route::resource('employees', EmployeeController::class)->except('show');
});

app/Models/Employee.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Employee extends Model
{
    use HasFactory;
    protected $fillable = [
        'first_name',
        'last_name',
        'email',
        'company_id',
        'phone',
    ];
    protected $table = 'employees';
    public function company(){
        return $this->belongsTo(Company::class);
     }
}

app/Http/Controllers/Admin/EmployeeController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Employee;
use App\Http\Requests\StoreEmployeeRequest;
use App\Http\Requests\UpdateEmployeeRequest;
use App\Models\Company;
use App\Repositories\EmpolyeeRepository;
use Illuminate\Pagination\Paginator;

class EmployeeController extends Controller
{
    private $repository;
    public function __construct(EmpolyeeRepository $repository)
    {
        $this->repository = $repository;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        Paginator::useBootstrap();
        $employees = Employee::with('company')->paginate('10');
        return view('dashboard.employee.index', compact('employees'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $companies = Company::get();
        return view('dashboard.employee.create', compact('companies'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \App\Http\Requests\StoreEmployeeRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreEmployeeRequest $request)
    {
        $this->repository->create($request->validated());
        return redirect()->route('admin.employees.index')->withSuccess('Created successfully.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Employee  $employee
     * @return \Illuminate\Http\Response
     */


    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Employee  $employee
     * @return \Illuminate\Http\Response
     */
    public function edit(Employee $employee)
    {
        $companies = Company::get();
        return view('dashboard.employee.edit', compact('employee', 'companies'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \App\Http\Requests\UpdateEmployeeRequest  $request
     * @param  \App\Models\Employee  $employee
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateEmployeeRequest $request, Employee $employee)
    {
        $this->repository->update($employee->id, $request->validated());

        return redirect()->route('admin.employees.index')->withSuccess('Updated successfully.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Employee  $employee
     * @return \Illuminate\Http\Response
     */
    public function destroy(Employee $employee)
    {
        $this->repository->delete($employee->id);
        return 'Deleted successfully.';
    }
}

resources/views/dashboard/employee/create.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="card mb-4">
            <form action="{{ route('admin.employees.store') }}" method="post" class="p-4" enctype="multipart/form-data">
                @csrf
                @method('post')
                <h5 class="card-header">Add New Employee </h5>
                <div class="card-body demo-vertical-spacing demo-only-element">
                    <div class="input-group">
                        <img class="input-group-text" width="55px"
                            src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAB4AAAAeCAYAAAA7MK6iAAAAAXNSR0IArs4c6QAAAP1JREFUSEvtltENwjAMRF8ngA1gBSaATWATYANGYBNgA0aASUCHMLKqRCLFNCA1Un+syC++nN00VFpNJS4DuDfl21KvgDUwDT7BBdgCe8vrwQvgEAxsp5sBZwU9ePOsVnGdLnJJRcsrThYc7fbbX4FThjsB8oStHbAExi6m63rIChRXnDOcB3tveF98BM4ZTu1hrXEE5sDVtwuguL5OFXtwznAGbsvvqy+WegCnhsrXpbbWENwbycDecNqjO+9srmrtpJNrgKjaidM5NUC0bxQ1QKJ+FMXt1DvYGykCbvleY/QnHgI5I0VUrPZT1cmnTwTg7RzRL40BnFWgmtR3GzFkH/kaNR0AAAAASUVORK5CYII=" />
                        <input type="text" required
                            class="form-control {{ $errors->has('first_name') ? ' is-invalid' : '' }}"
                            placeholder="first_name" aria-label="first_name" value="{{ old('first_name') }}"
                            name='first_name' />
                        @if ($errors->has('first_name'))
                            <span class="invalid-feedback text-right" style="display: block;" role="alert">
                                <strong>{{ $errors->first('first_name') }}</strong>
                            </span>
                        @endif

                    </div>
                    <div class="input-group">
                        <img class="input-group-text" width="55px"
                            src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAB4AAAAeCAYAAAA7MK6iAAAAAXNSR0IArs4c6QAAAP1JREFUSEvtltENwjAMRF8ngA1gBSaATWATYANGYBNgA0aASUCHMLKqRCLFNCA1Un+syC++nN00VFpNJS4DuDfl21KvgDUwDT7BBdgCe8vrwQvgEAxsp5sBZwU9ePOsVnGdLnJJRcsrThYc7fbbX4FThjsB8oStHbAExi6m63rIChRXnDOcB3tveF98BM4ZTu1hrXEE5sDVtwuguL5OFXtwznAGbsvvqy+WegCnhsrXpbbWENwbycDecNqjO+9srmrtpJNrgKjaidM5NUC0bxQ1QKJ+FMXt1DvYGykCbvleY/QnHgI5I0VUrPZT1cmnTwTg7RzRL40BnFWgmtR3GzFkH/kaNR0AAAAASUVORK5CYII=" />
                        <input type="text" required
                            class="form-control {{ $errors->has('last_name') ? ' is-invalid' : '' }}"
                            placeholder="last_name" aria-label="last_name" value="{{ old('last_name') }}"
                            name='last_name' />
                        @if ($errors->has('last_name'))
                            <span class="invalid-feedback text-right" style="display: block;" role="alert">
                                <strong>{{ $errors->first('last_name') }}</strong>
                            </span>
                        @endif

                    </div>

                    <div class="input-group">

                        <img class="input-group-text" width="55px"
                            src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAB4AAAAeCAYAAAA7MK6iAAAAAXNSR0IArs4c6QAAAUNJREFUSEvN1+FtwjAQhuGXDToCTNBuUDoBYgQmaDdomQBGKBswAiPABHSDlg2qTyLIoPh856Sk/oMQdh5/F8cxIwZqo4FcbuExMAMeHBP6ATaAPsMthYUeg1f4AubAPjjuKvEbsIpe4Jz4JYqniT+A9wpYQ1TuEG7BJ2AN7M73XBN7NCYWwi14CQhrmhbcd6EibtyCVTqlTZu+P/eBW7BW6zaYuOleTG7BekSUWhdRmV9vSl9ahybuWdUq77SkZH7P4h640rwMa8XvAWsG2uEmaYIUrt25vBVZAJ9N5xTWAtL9tDYJL9LWLwur81/hB+ApV+p0h+ozuVA9FVevz9xBoK/kragSWieQrngWLcFd7rmJeuAavIh64QjuQiOwB3ejUdjCQ2gN3IaH0Vq4wbW3q+lcFj5b/5t/El1eAqGxgyX+BeC9Ux+v9IFjAAAAAElFTkSuQmCC" />
                        <input type="email" required class="form-control {{ $errors->has('email') ? ' is-invalid' : '' }}"
                            placeholder="email" aria-label="email" name="email" value="{{ old('email') }}" />
                        @if ($errors->has('email'))
                            <span class="invalid-feedback text-right" style="display: block;" role="alert">
                                <strong>{{ $errors->first('email') }}</strong>
                            </span>
                        @endif
                    </div>

                    <div class="input-group">

                        <img class="input-group-text" width="55px"
                            src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAB4AAAAeCAYAAAA7MK6iAAAAAXNSR0IArs4c6QAAAUNJREFUSEvN1+FtwjAQhuGXDToCTNBuUDoBYgQmaDdomQBGKBswAiPABHSDlg2qTyLIoPh856Sk/oMQdh5/F8cxIwZqo4FcbuExMAMeHBP6ATaAPsMthYUeg1f4AubAPjjuKvEbsIpe4Jz4JYqniT+A9wpYQ1TuEG7BJ2AN7M73XBN7NCYWwi14CQhrmhbcd6EibtyCVTqlTZu+P/eBW7BW6zaYuOleTG7BekSUWhdRmV9vSl9ahybuWdUq77SkZH7P4h640rwMa8XvAWsG2uEmaYIUrt25vBVZAJ9N5xTWAtL9tDYJL9LWLwur81/hB+ApV+p0h+ozuVA9FVevz9xBoK/kragSWieQrngWLcFd7rmJeuAavIh64QjuQiOwB3ejUdjCQ2gN3IaH0Vq4wbW3q+lcFj5b/5t/El1eAqGxgyX+BeC9Ux+v9IFjAAAAAElFTkSuQmCC" />
                        <input type="number" required
                            class="form-control {{ $errors->has('phone') ? ' is-invalid' : '' }}" placeholder="phone"
                            aria-label="phone" name="phone" value="{{ old('phone') }}" />
                        @if ($errors->has('phone'))
                            <span class="invalid-feedback text-right" style="display: block;" role="alert">
                                <strong>{{ $errors->first('phone') }}</strong>
                            </span>
                        @endif
                    </div>
                    <div class="input-group">

                        <select name="company_id"
                            class="form-select form-select-lg {{ $errors->has('company_id') ? ' is-invalid' : '' }}">
                            <option value="">
                                select company
                            </option>
                            @foreach ($companies as $company)
                                <option value="{{ $company->id }}" {{ old('company_id') ? 'selected' : '' }}>
                                    {{ $company->name }}</option>
                            @endforeach
                        </select>
                        @if ($errors->has('company_id'))
                            <span class="invalid-feedback text-right" style="display: block;" role="alert">
                                <strong>{{ $errors->first('company_id') }}</strong>
                            </span>
                        @endif
                    </div>
                    <button class="btn btn-primary btn-style " type="submit">Add</button>
                </div>
            </form>
        </div>
    </div>
@endsection

resources/views/dashboard/employee/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="card mb-4">
            <form action="{{ route('admin.employees.update', $employee->id) }}" method="post" class="p-4"
                enctype="multipart/form-data">
                @csrf
                @method('put')
                <h5 class="card-header">Update Employee Information</h5>
                <div class="card-body demo-vertical-spacing demo-only-element">
                    <div class="input-group">
                        <img class="input-group-text" width="55px"
                            src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAB4AAAAeCAYAAAA7MK6iAAAAAXNSR0IArs4c6QAAAcxJREFUSEvlle0xBEEQhp+LgAwQASJABmRABIgAESACIZABIkAEhEAE1KNmrub2ZmZ7+eGHrrrarduefvt9pz9m/JHN/giXnwLvApsp6WfgcSqBqcD7wA2wOgB6B46Au2gCU4CvgOORwKeAfqMWBVba+xRNWQ3+AMhUFU6AnfR9L33rgkeBvUfv9AXYakR8A9YAfbfHKEeBP1OgnpTnwFnyG4076gCUMvdkjPp95xYBXgdeE5ODTuUeporXdQNQ+qZFgD1sEa0A16mQagFz1X9U2m3JPwpctlJN7lLmXnLzBKLADgzbJ08r363e3E650ntVv8A6Cuwh79rJlMGH8tnf3nP3bvOhKcD5jMPCoZFZytyEQhPrN8BjsyH0PcpYdkrsszW5ZO7Pe/b5q5FpUbmNlHaKKb3byuKrWo9xbQXaoy02KmGvZ+uuyhawQZ6KIPamxTNWsVa+xVeuTxfGUrIt4LyNZChz+3aKeeY2HahuqxpwuWXCi72Slcwv0/8XgHHnVgOWnUs9PIU6UmTlHC6O1S5w3r1LWU7ROvk2d/SQcVlUvRUYzaG864UiGwJPWuYB9Ga8IbADo5zBzQEQANWlGS86MoM4cbf/B/wF5GpcH3yxaxIAAAAASUVORK5CYII=" />
                        {{-- <span >Full name</span> --}}
                        <input type="text" class="form-control {{ $errors->has('first_name') ? ' is-invalid' : '' }}"
                            placeholder="first_name" aria-label="first_name" value="{{ $employee->first_name }}"
                            name='first_name' required />
                        @if ($errors->has('first_name'))
                            <span class="invalid-feedback text-right" style="display: block;" role="alert">
                                <strong>{{ $errors->first('first_name') }}</strong>
                            </span>
                        @endif
                    </div>
                    <div class="input-group">
                        <img class="input-group-text" width="55px"
                            src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAB4AAAAeCAYAAAA7MK6iAAAAAXNSR0IArs4c6QAAAcxJREFUSEvlle0xBEEQhp+LgAwQASJABmRABIgAESACIZABIkAEhEAE1KNmrub2ZmZ7+eGHrrrarduefvt9pz9m/JHN/giXnwLvApsp6WfgcSqBqcD7wA2wOgB6B46Au2gCU4CvgOORwKeAfqMWBVba+xRNWQ3+AMhUFU6AnfR9L33rgkeBvUfv9AXYakR8A9YAfbfHKEeBP1OgnpTnwFnyG4076gCUMvdkjPp95xYBXgdeE5ODTuUeporXdQNQ+qZFgD1sEa0A16mQagFz1X9U2m3JPwpctlJN7lLmXnLzBKLADgzbJ08r363e3E650ntVv8A6Cuwh79rJlMGH8tnf3nP3bvOhKcD5jMPCoZFZytyEQhPrN8BjsyH0PcpYdkrsszW5ZO7Pe/b5q5FpUbmNlHaKKb3byuKrWo9xbQXaoy02KmGvZ+uuyhawQZ6KIPamxTNWsVa+xVeuTxfGUrIt4LyNZChz+3aKeeY2HahuqxpwuWXCi72Slcwv0/8XgHHnVgOWnUs9PIU6UmTlHC6O1S5w3r1LWU7ROvk2d/SQcVlUvRUYzaG864UiGwJPWuYB9Ga8IbADo5zBzQEQANWlGS86MoM4cbf/B/wF5GpcH3yxaxIAAAAASUVORK5CYII=" />
                        {{-- <span >Full name</span> --}}
                        <input type="text" class="form-control {{ $errors->has('last_name') ? ' is-invalid' : '' }}"
                            placeholder="last_name" aria-label="last_name" value="{{ $employee->last_name }}"
                            name='last_name' required />
                        @if ($errors->has('last_name'))
                            <span class="invalid-feedback text-right" style="display: block;" role="alert">
                                <strong>{{ $errors->first('last_name') }}</strong>
                            </span>
                        @endif
                    </div>

                    <div class="input-group">

                        <img class="input-group-text" width="55px"
                            src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAB4AAAAeCAYAAAA7MK6iAAAAAXNSR0IArs4c6QAAAMlJREFUSEvtlkERwjAQRV8d4KCgAJwUBwwOcAAOigRwAApAAhLACbOHXGgmGzYp5bA99+f1b392fsNETzMRlxzwDOiAueEjr8AjptPAAr0BKwM0SLbA6VOvgXdAXwAV6RNYfAs+APtCsMgHBjXHDrZO3UetLhAPl4crdwJ+nfw6DbLytwvkDFyAI9AmIl491eFAqTabX4IFGBynymB1x6MtkBpl7xWrxlrnknp7B5a51iLvmeqtnCPwtbHQy/83FfoCo2mpNurRwG/UcSUfMoEwVwAAAABJRU5ErkJggg==" />
                        <input type="email" required class="form-control {{ $errors->has('email') ? ' is-invalid' : '' }}"
                            placeholder="email" aria-label="email" name="email" value="{{ $employee->email }}" />
                        @if ($errors->has('email'))
                            <span class="invalid-feedback text-right" style="display: block;" role="alert">
                                <strong>{{ $errors->first('email') }}</strong>
                            </span>
                        @endif
                    </div>
                    <div class="input-group">
                        <img class="input-group-text" width="55px"
                            src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAB4AAAAeCAYAAAA7MK6iAAAAAXNSR0IArs4c6QAAAcxJREFUSEvlle0xBEEQhp+LgAwQASJABmRABIgAESACIZABIkAEhEAE1KNmrub2ZmZ7+eGHrrrarduefvt9pz9m/JHN/giXnwLvApsp6WfgcSqBqcD7wA2wOgB6B46Au2gCU4CvgOORwKeAfqMWBVba+xRNWQ3+AMhUFU6AnfR9L33rgkeBvUfv9AXYakR8A9YAfbfHKEeBP1OgnpTnwFnyG4076gCUMvdkjPp95xYBXgdeE5ODTuUeporXdQNQ+qZFgD1sEa0A16mQagFz1X9U2m3JPwpctlJN7lLmXnLzBKLADgzbJ08r363e3E650ntVv8A6Cuwh79rJlMGH8tnf3nP3bvOhKcD5jMPCoZFZytyEQhPrN8BjsyH0PcpYdkrsszW5ZO7Pe/b5q5FpUbmNlHaKKb3byuKrWo9xbQXaoy02KmGvZ+uuyhawQZ6KIPamxTNWsVa+xVeuTxfGUrIt4LyNZChz+3aKeeY2HahuqxpwuWXCi72Slcwv0/8XgHHnVgOWnUs9PIU6UmTlHC6O1S5w3r1LWU7ROvk2d/SQcVlUvRUYzaG864UiGwJPWuYB9Ga8IbADo5zBzQEQANWlGS86MoM4cbf/B/wF5GpcH3yxaxIAAAAASUVORK5CYII=" />                        <input type="text" class="form-control {{ $errors->has('phone') ? ' is-invalid' : '' }}"
                            placeholder="phone" aria-label="phone" value="{{ $employee->phone }}" name='phone'
                            required />
                        @if ($errors->has('phone'))
                            <span class="invalid-feedback text-right" style="display: block;" role="alert">
                                <strong>{{ $errors->first('phone') }}</strong>
                            </span>
                        @endif
                    </div>
                    <div class="input-group">

                        <select name="company_id"
                            class="form-select form-select-lg {{ $errors->has('company_id') ? ' is-invalid' : '' }}">
                            <option value="">
                                select company
                            </option>
                            @foreach ($companies as $company)
                                <option value="{{ $company->id }}"
                                    {{ $employee->company_id == $company->id ? 'selected' : '' }}>
                                    {{ $company->name }}</option>
                            @endforeach
                        </select>
                        @if ($errors->has('company_id'))
                            <span class="invalid-feedback text-right" style="display: block;" role="alert">
                                <strong>{{ $errors->first('company_id') }}</strong>
                            </span>
                        @endif
                    </div>
                    <button class="btn btn-primary btn-style" type="submit">Update</button>
                </div>
            </form>
        </div>
    </div>
@endsection

resources/views/dashboard/employee/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="container-xxl flex-grow-1 container-p-y">
        <h4 class="fw-bold py-3 mb-4"><span class="text-muted fw-light">Tables /</span> Employee</h4>

        <!-- Basic Bootstrap Table -->

        <div class="card h-100">
            <div class="row">
                <div class="col-lg-10 col-12">
                    <h5 class="card-header">Employee Table </h5>
                </div>
                <div class="col-lg-2 col-12 p-3">
                    <a href="{{ route('admin.employees.create') }}" class="btn btn-primary btn-block w-100 ">
                        Add Employee
                    </a>
                </div>
            </div>
            <div class="table-responsive text-nowrap h-100">

                <table class="table">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>First name</th>
                            <th>Last name</th>
                            <th>Email</th>
                            <th>Company name</th>
                            <th>Phone</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody class="table-border-bottom-1 ">
                        @include('dashboard.employee.table')
                    </tbody>
                </table>
                <div class="row align-items-center text-center mt-5">
                    <div class="col-12 col-lg-4 "></div>
                    <div class="col-12 col-lg-4 text-center ">
                        <div class="pageination text-center ">
                            {!! $employees->links() !!}
                        </div>
                    </div>
                    <div class="col-12 col-lg-4 "></div>
                </div>
            </div>
        </div>
        <hr class="my-5" />
    </div>
@endsection

resources/views/dashboard/employee/table.blade.php
@foreach ($employees as $item)
    <tr>
        <td>{{ $item->id }}</td>
        <td>{{ $item->first_name }}</td>
        <td>{{ $item->last_name }}</td>
        <td>{{ $item->email }}</td>
        <td>{{ $item->company_id }}</td>
        <td>{{ $item->phone }}</td>

        <td>
            <div class="dropdown">
                <button type="button" class="btn p-0 dropdown-toggle hide-arrow" data-bs-toggle="dropdown">
                    <i class="bx bx-dots-vertical-rounded"></i>
                </button>
                <div class="dropdown-menu">
                    <a class="dropdown-item" href="{{ route('admin.employees.edit', $item->id) }}"><i
                            class="bx bx-edit-alt me-1"></i>
                        Edit</a>
                    <a class="dropdown-item deleteItem" data-url='{{ route('admin.employees.destroy', $item->id) }}'
                        href="#"><i class="bx bx-trash me-1"></i>
                        Delete</a>
                </div>

            </div>
        </td>
    </tr>
@endforeach